package op;

import com.cycling74.max.*;
import java.util.Arrays;
import java.util.ArrayList;
import java.util.List;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;

public class coll extends MaxObject {

	private int[] arr = new int[4];
	private List<List<Atom>> listOfLists = new ArrayList<List<Atom>>();

	private Atom[] path = null;
	private Atom[][] in, out;
	public int iterate = 0;
	public boolean autoBang = true;

	coll() {
		declareIO(2, 2);
		createInfoOutlet(false);
	}

	public void add(Atom[] a) {
		ArrayList<Atom> ar = new ArrayList<Atom>(Arrays.asList(a));
		listOfLists.add(ar);
		iterate = iterate + 1;
	}

	public void length() {
		outlet(1, Atom.newAtom(iterate));
	}

	public void clear() {
		iterate = 0;
		listOfLists.clear();
		outlet(1, "bang");
	}

	public void setpath (Atom[] patho) {
		path = patho;
	}

	public void clearpath() {
		path = null;
	}

	public void deferclear() {
		Thread t = new Thread() {
			public void run() {
				iterate = 0;
				listOfLists.clear();
			}
		};
		t.start();
		outlet(1, "bang");
	}

	public void deletefile(Atom[] patho) throws IOException {
		if (patho == null) {
			error("op.coll-> deletefile must be followed by a path for its first time");
		} else {
			if (patho.length != 0) {
				path = patho;				
		}
		File file = new File(path[0].toString());
		boolean boo = file.delete();
		outlet(1, "bang");
		}
	}

	public void deferdeletefile(Atom[] patho) throws IOException {
		if (patho == null) {
			error("op.coll-> deferdeletefile must be followed by a path for its first time");
		} else {
			if (patho.length != 0) {
				path = patho;				
		}
		Thread t = new Thread() {
			public void run() {
				File file = new File(path[0].toString());
				boolean boo = file.delete();
			}
		};
		t.start();
		outlet(1, "bang");
		}
	}

	public void sort() {

//		Comparator comparator = Collections.reverseOrder();
		error("op.coll-> SORT not ready yet");

//		System.out.println("COCOTTE TYPE : " + listOfLists.getClass().getName());
//		System.out.println("COCOTTE : " + arr.toString());

/*	Comparator<ArrayList<Atom>> myComparator = new Comparator<ArrayList<Atom>>() {
		@Override
        public int compare(ArrayList<Atom> o1, ArrayList<Atom> o2) {
            return o1.get(0).compareTo(o2.get(0));
        }
    };*/

//		Collections.sort(listOfLists, myComparator);
//		Collections.sort(listOfLists, comparator);
//		Collections.sort(listOfLists);
//		System.out.println("COCOTTE2 : " + listOfLists);
//		outlet(0, Atom.newAtom(listOfLists));
//		outlet(1, Atom.newAtom(iterate));

		}

	public void dump() {
		int count = 0; 		
		while (listOfLists.size() > count) {
			Atom[] outList = new Atom[listOfLists.get(count).size()];
			int start = 0;
			while (start < listOfLists.get(count).size()) {
				outList[start] = listOfLists.get(count).get(start);
				start++;
			}
			outlet(0, outList);
			count++;
		}
		outlet(1, "bang");
	}

	public void deferdump() {
		Thread t = new Thread() {
		public void run() {
			int count = 0;
			while (listOfLists.size() > count) {
				Atom[] outList = new Atom[listOfLists.get(count).size()];
				int start = 0;
				while (start < listOfLists.get(count).size()) {
					outList[start] = listOfLists.get(count).get(start);
					start++;
				}
			outlet(0, outList);
			count++;
			}
		}	
	};
	t.start();
	outlet(1, "bang");
	}

// setOutput(0, new Atom[] {Atom.newAtom(total)});

	public void write(Atom[] patho) throws IOException {
		if (patho == null) {
			error("op.coll-> write must be followed by a path for its first time");
		} else {
			if (patho.length != 0) {
				path = patho;				
		}
		File file = new File(path[0].toString());
		FileWriter fw = new FileWriter(file.getAbsoluteFile());
		BufferedWriter bw = new BufferedWriter(fw);
		int count = 0;
		int count2 = 0;
		while (listOfLists.size() > count) {
			while (listOfLists.size() > count2) {
				String strRet="";
				Atom[] outList = new Atom[listOfLists.get(count2).size()];
				int start = 0;
				int sizee = listOfLists.get(count2).size();
				while (start < sizee) {
					outList[start] = listOfLists.get(count2).get(start);
					strRet += listOfLists.get(count2).get(start).toString();
					if (start!=sizee-1) {
						strRet += "\t";
					}
					start++;
				}
			bw.write(strRet);
			bw.write("\n");
			count2++;
			}
		count++;
		}
		bw.close();
		outlet(1, "bang");
	}
}

	public void deferwrite(Atom[] patho) {
		if (patho == null) {
			error("op.coll-> deferwrite must be followed by a path for its first time");
		} else {
			if (patho.length != 0) {
				path = patho;				
		}
		Thread t = new Thread() {
		public void run() {
			try {
				File file = new File(path[0].toString());
				final FileWriter fw = new FileWriter(file.getAbsoluteFile());
				final BufferedWriter bw = new BufferedWriter(fw);
				int count = 0;
				int count2 = 0;
				while (listOfLists.size() > count) {
					while (listOfLists.size() > count2) {
						String strRet="";
						Atom[] outList = new Atom[listOfLists.get(count2).size()];
						int start = 0;
						int sizee = listOfLists.get(count2).size();
						while (start < sizee) {
							outList[start] = listOfLists.get(count2).get(start);
							strRet += listOfLists.get(count2).get(start).toString();
							if (start!=sizee-1) {
								strRet += "\t";
							}
							start++;
						}
					bw.write(strRet);
					bw.write("\n");
					count2++;
					}
				count++;
				}
				bw.close();
			}
			catch(IOException exc)
			{
				error("op.coll-> cannot write file");
			}
		}
		};
		t.start();
		outlet(1, "bang");
		}
	}
}





